package com.qy.worksheetsystem.model.mapper;

import com.qy.worksheetsystem.model.entity.JobBooking;
import org.apache.ibatis.annotations.MapKey;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

@Repository
public interface PersonWorkMapper {

        String selectBillKey(@Param("time") long time);
        String selectKeyByBosTyoe(@Param("employeeID") String employeeID,@Param("time") long time);

        List<Map<String,Object>> getAvailableDateInfo(@Param("employeeID") String employeeID, @Param("startDate")String startDate,  @Param("endDate")String endDate);
        List<Map<String,Object>> getAvailableDateInfoById(@Param("employeeID") String employeeID,@Param("id") String id, @Param("startDate")String startDate,  @Param("endDate")String endDate);

        int insertBill(@Param("billList")List<Map<String, Object>> billList);

        int insertWork(@Param("workList")List<Map<String, Object>> workList);

        List<Map<String,Object>> getPersonWorkList(String number,String beginTime, String endTime, Boolean state);
        List<JobBooking> getPersonWorkListV2(String number,String beginTime, String endTime, Boolean state);

        List<Map<String,Object>> getPersonWorkSumInfo(String number,String beginTime, String endTime, Boolean state);
        JobBooking getPersonWorkInfoById(String number,String id);

        int deleteWork(String id);
        int deleteWorkEntry(String id);
}
