package com.kingdee.eas.hr.project.handler;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.hr.project.WorkHoursFacadeFactory;
import com.kingdee.shr.base.syssetting.api.bean.BatchMessageTipsBody;
import com.kingdee.shr.base.syssetting.api.bean.BatchMessageTipsHeader;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.web.handler.ListHandler;

public class WorkHoursReportListHandler extends ListHandler {

	private static Logger logger = Logger.getLogger(WorkHoursReportListHandler.class);
	
	/**
	 * 
	 * @param request
	 * @param response
	 * @param modelMap
	 * @throws SHRWebException
	 */
	public void initWorkHoursReportAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap)
			throws SHRWebException {
		Context ctx = SHRContext.getInstance().getContext();
		String billIds = request.getParameter("billId");
		BatchMessageTipsHeader batchMessageTipsHeader = new BatchMessageTipsHeader();
		int success = 0;
		int failure = 0;

		BatchMessageTipsBody body = new BatchMessageTipsBody();
		try {
				WorkHoursFacadeFactory.getLocalInstance(ctx).updateWorkHoursReport(null, null, null, 100, "update");
				body.setMuitTipsState(Boolean.TRUE);
				body.setMuitTipsMessage("óɹ");
				batchMessageTipsHeader.addResult(body);
		} catch (EASBizException var18) {
			logger.error(var18.getMessage(), var18);
			++failure;
			body.setMuitTipsState(Boolean.FALSE);
			body.setMuitTipsMessage("ʧܣ" + var18.getMessage());
			batchMessageTipsHeader.addResult(body);
		} catch (BOSException var19) {
			logger.error(var19.getMessage(), var19);
			++failure;
			body.setMuitTipsState(Boolean.FALSE);
			body.setMuitTipsMessage("ʧܣ" + var19.getMessage());
			batchMessageTipsHeader.addResult(body);
		}

		batchMessageTipsHeader.setBillId(billIds);
		batchMessageTipsHeader.setFailureCount(failure);
		batchMessageTipsHeader.setSuccessCount(success);
		this.writeSuccessData(batchMessageTipsHeader);
	}
}
